SystemOrganization addCategory: #ConfigurationOfDripfeedIt!

Object subclass: #ConfigurationOfDripfeedIt
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfDripfeedIt'!

!ConfigurationOfDripfeedIt class methodsFor: 'development support' stamp: 'PhilippeBack 6/21/2013 12:25'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfDripfeedIt class methodsFor: 'private' stamp: 'PhilippeBack 6/21/2013 12:25'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfDripfeedIt class methodsFor: 'private' stamp: 'PhilippeBack 6/21/2013 12:25'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfDripfeedIt class methodsFor: 'private' stamp: 'PhilippeBack 6/21/2013 12:25'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfDripfeedIt class methodsFor: 'metacello tool support' stamp: 'PhilippeBack 6/21/2013 12:25'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfDripfeedIt class methodsFor: 'loading' stamp: 'PhilippeBack 6/21/2013 12:25'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfDripfeedIt class methodsFor: 'loading' stamp: 'PhilippeBack 6/21/2013 12:25'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfDripfeedIt class methodsFor: 'loading' stamp: 'PhilippeBack 6/21/2013 12:25'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfDripfeedIt class methodsFor: 'accessing' stamp: 'PhilippeBack 6/21/2013 12:25'!
project

	^self new project! !

!ConfigurationOfDripfeedIt class methodsFor: 'development support' stamp: 'PhilippeBack 6/21/2013 12:25'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfDripfeedIt methodsFor: 'baselines' stamp: 'PhilippeBack 6/21/2013 12:30'!
baseline01: spec 
        <version: '0.1-baseline'>
        
        spec for: #common do: [
                spec blessing: #baseline.
		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/DripfeedIt/main'.    
		
   	             spec project: 'HOWebStack' with: [ 
				spec
					className: 'ConfigurationOfHOWebStack';
					versionString: #development;
					file: 'ConfigurationOfHOWebStack';
					repository: 'http://www.smalltalkhub.com/mc/philippeback/HOWebStack/main' ].		
		
		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/DripfeedIt/main'.
	          spec 
                        package: 'DripfeedIt-Domain';
				package: 'DripfeedIt-Persistence';
				package: 'DripfeedIt-REST';
				package: 'DripfeedIt-Tests-Domain';
				package: 'DripfeedIt-Tests-Workflow';
				package: 'DripfeedIt-Webapplication';
				package: 'DripfeedIt-Workflow';
				package: 'DripfeedIt-WorkflowExecution';
				package: 'DripfeedIt-WorkflowSupport'.

	].! !

!ConfigurationOfDripfeedIt methodsFor: 'accessing' stamp: 'PhilippeBack 6/21/2013 12:25'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfDripfeedIt methodsFor: 'symbolic versions' stamp: 'PhilippeBack 6/21/2013 12:25'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #common version: '0.1'.

! !

!ConfigurationOfDripfeedIt methodsFor: 'accessing' stamp: 'PhilippeBack 6/21/2013 12:25'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfDripfeedIt methodsFor: 'versions' stamp: 'PhilippeBack 6/21/2013 12:25'!
version01: spec 
        <version: '0.1' imports: #('0.1-baseline') >
       ! !
